#include <stdlib.h>
#include <stdio.h>
#include "lista.h"

/*-------------------------------------------------------------------*/
lista *cria_lista(lista *l) { 

  *l = NULL; 

  return l;
}
/*-------------------------------------------------------------------*/
no *insere(int o, lista *l) {

  no *novo = malloc(sizeof(no));
  
  if ( ! novo ) return NULL;

  novo->elemento = o;
  novo->proximo = *l;

  return *l = novo;
}
/*-------------------------------------------------------------------*/
static int remove_filho(pai_de_no *pai) {

  if ( !pai ) return 0;

  no *liberado = *pai;
  (*pai) = (*pai)->proximo;
  free(liberado);

  return 1;
}
/*-------------------------------------------------------------------*/
lista *destroi_lista (lista *l) { 
  while ( *l ) remove_filho(l); 
  return l;
}
/*-------------------------------------------------------------------*/
static pai_de_no *procura_pai(int o, lista *l) {
  
  no *p;
  pai_de_no *pai_de_p;

/*
  for ( p=*l, pai_de_p=l; p; pai_de_p=&p->proximo, p=p->proximo ) 
*/

  p = *l;
  pai_de_p = l;
  while (p) {
    if ( p->elemento == o ) 
      return pai_de_p;

    pai_de_p=&p->proximo;
    p=p->proximo; 
  }

  return NULL;
}
/*-------------------------------------------------------------------*/
no *procura(int o, lista l) {
  
  no **p = procura_pai(o,&l);

  return p ? (*p)->proximo : NULL;
}
/*-------------------------------------------------------------------*/
int remove_no(int o, lista *l) { 
  
  return remove_filho(procura_pai(o,l)); 
}
/*-------------------------------------------------------------------*/
void escreve(lista l) {

  no *p;

  printf("( ");

  for ( p=l; p && p->proximo; p=p->proximo ) {
    
    printf("%d", p->elemento);
    printf(" ");
  }

  if ( p )     printf("%d", p->elemento);

  printf(" )");

}
